
function [V,cell_voltage]=predict_error(theta_predict)
load beta.mat
load volts_pulse300s_02soc_part.mat
load volts_pulse300s_08soc_part.mat

global eta i_app tem conc_o concS_o sv sigmaEffFACE porosityNODE diffuFACE...
       dx n_n n_s n_t n_p nr dt FARADAY RU porosity_n porosity_s porosity_p poroActive_n poroActive_p...
       diffu diffuSolid_n diffuSolid_p tPlus R_s alpha_a alpha_c concS_max_n...
       concS_max_p kcon_n kcon_p sigma_n sigma_p A_csp A_csn A_cs A_phie A_ce A_phis A jli stoic_p
x_min=[3.7e-20;2.6e-12;3e-7;2e-4;1e-7];
x_max=[3.7e-12;2.6e-9;30;2e-2;1e-5];
diffu_solidp_exp=theta_predict(1)*log10(x_min(1))+(1-theta_predict(1))*log10(x_max(1));
diffu_exp=theta_predict(2)*log10(x_min(2))+(1-theta_predict(2))*log10(x_max(2));
sigma_p_exp=theta_predict(3)*log10(x_min(3))+(1-theta_predict(3))*log10(x_max(3));
resistance_exp=theta_predict(4)*log10(x_min(4))+(1-theta_predict(4))*log10(x_max(4));
Rs_exp=theta_predict(5)*log10(x_min(5))+(1-theta_predict(5))*log10(x_max(5));
% diffu_solidn_exp=theta_predict(6)*log10(x_min(6))+(1-theta_predict(6))*log10(x_max(6));
%  R_s=theta_predict(1);
 diffu=10^diffu_exp;
%  alpha_a=theta_predict(3);
diffuSolid_p=10^diffu_solidp_exp;
 sigma_p=10^sigma_p_exp;
 resistance=10^resistance_exp;
 R_s=10^Rs_exp;
 num=2;
 voltage_pulse_sep=cell(1:num);
%  diffuSolid_n=10^diffu_solidn_exp;
for count=1:num
%% Set up grid parameter, material properties, and initial conditions
    % -------------------------------------------------------------------------
    % Charging / Discharging Condition
    charge = false;              % Initially Assume Charging Cycle
    % -------------------------------------------------------------------------
    % Hybrid Cycle
    hybrid_cycle = true;
    % -------------------------------------------------------------------------
    % Simulation Time 
    time =1600;               	% Simulation End Time [UNIT: seconds]
 
    % -------------------------------------------------------------------------
settings;
%% preallocation 
           Cs=zeros(time,nr*(n_n+n_p));
           Ce=zeros(time,n_t);
           Phie=zeros(time,n_t);
           Phis=zeros(time,n_n+n_p);
           Cse=zeros(time,n_t);
           F_phis1=zeros((n_n+n_p),1);
           J_phis1=zeros((n_n+n_p),(n_n+n_p));
           F_ce1=zeros(n_t,1);
           J_ce1=spalloc(n_t,n_t,n_t*3-2);
           F_phie1=zeros(n_t,1);
           J_phie1=spalloc(n_t,n_t,n_t*3-2);
           F_cs1=zeros(nr*(n_n+n_p),1);
           J_cs1=spalloc(nr*(n_n+n_p),nr*(n_n+n_p),nr*(n_n+n_p)*3-2);
           A_csn = spalloc(nr,nr,3*nr-2);
           A_csp = spalloc(nr,nr,3*nr-2);
           A_cs = spalloc(nr*(n_n+n_p),nr*(n_n+n_p),3*nr*(n_n+n_p)-2);
           A_phie=zeros(n_t,n_t);%% preallocation
           A_ce=zeros(n_t,n_t);%% preallocation
           A_phis=zeros(n_n+n_p,n_n+n_p);%% preallocation
           jli_dis=[];
%% define control variables
tol=1e-4*2; %% tolerance
alpha=0.5; %% damping ratio
%% define the sub functions 
F_cs='bat_F_cs';
F_ce='bat_F_ce';
F_phie='bat_F_phie';
F_phis='bat_F_phis';
J_cs='bat_cs_J';
J_ce='bat_ce_J';
J_phie='bat_phie_J';
J_phis='bat_phis_J';
%% define input of the subfunctions
% x(1:n_n)=stoic_n;
% y(1:n_t)=stoic_p;
% delta_y(1:n_t)=1e-4;
y_in=[phiS,phiE,conc,concS,concS_surf];
tic
for t=1:time_max
%     t*dt
   for iter=1:iter_max
       loop_eqpot;
       %%%%%%%%% phis %%%%%%%%%%%%
       F_phis1=feval(F_phis,y_in);
       J_phis1=feval(J_phis,y_in);
       delta1=J_phis1\(-F_phis1);
       phiS=y_in(1:n_n+n_p);
       y1=phiS;
       phiS=phiS+(alpha*delta1)';
       dif(1)=norm(phiS-y1);
       for i=1:n_n+n_p   
           phiS(i)=min(max(phiS(i),phiS_min),phiS_max);
       end      
       etas;
       y_in=[phiS,phiE,conc,concS concS_surf];
       %%%%%%%%% phie %%%%%%%%%%%%
       F_phie1=feval(F_phie,y_in);
       J_phie1=feval(J_phie,y_in);
       delta2=J_phie1\(-F_phie1);
       phiE=y_in(1+n_n+n_p:n_n+n_p+n_t);
       y2=phiE;
       phiE=phiE+(alpha*delta2)';
       dif(2)=norm(phiE-y2);
       for i=1:n_t
           phiE(i)=min(max(phiE(i),phiE_min),phiE_max);
       end 
       etas;
       y_in=[phiS,phiE,conc,concS concS_surf];
       %%%%%%%%% conc %%%%%%%%%%%%       
       F_ce1=feval(F_ce,y_in);
       J_ce1=feval(J_ce,y_in);
       delta3=J_ce1\(-F_ce1);
       conc=y_in(n_n+n_p+n_t+1:n_n+n_p+n_t+n_t);
       y3=conc;
       conc=conc+(alpha*delta3)';
       dif(3)=norm(y3-conc);
       for i=1:n_t
           conc(i)=min(max(conc(i),conc_min),conc_max);
       end
       y_in=[phiS,phiE,conc,concS concS_surf];
       %%%%%%%%% concS %%%%%%%%%%%% 
       F_cs1=feval(F_cs,y_in);
       J_cs1=feval(J_cs,y_in); 
       delta4=J_cs1\(-F_cs1);
       concS=y_in(1+n_n+n_p+n_t+n_t:n_n+n_p+n_t+n_t+nr*(n_n+n_p));
       y4=concS;
       concS=concS+(alpha*delta4)';
       dif(4)=norm(y4-concS);
       for i=1:nr*n_n
           concS(i)=min(max(concS(i),conc_min),concS_max_n);
       end
       for i=n_n*nr+1:nr*(n_n+n_p)
           concS(i)=min(max(concS(i),conc_min),concS_max_p);
       end
       for i=1:n_n
           concS_surf(i)=concS(i*nr);
           concS_surf(i) = min(max(conc_min,concS_surf(i)),concS_max_n );
       end
       for i=n_n+1:n_n+n_p
           j=i+n_s;
           concS_surf(j)=concS((i)*nr);
           concS_surf(j) = min(max(conc_min,concS_surf(j)),concS_max_p );
       end 
%           x=concS_surf(1:n_n)./concS_max_n;
%           y=concS_surf(1:n_t)./concS_max_p;
%           delta_y(1:n_t)=1e-4;
       y_in=[phiS,phiE,conc,concS concS_surf];
       check;
       if iter==iter_max
           disp('NOT converged')
           return;
       end
       if converged==true

%            disp('converged')
           Cs(t,:)=concS;
           Ce(t,:)=conc;
           Phie(t,:)=phiE;
           Phis(t,:)=phiS;
           Cse(t,:)=concS_surf;
           break;
       end
    end  
    time_march; 
    post;

end
voltage_pulse_sep{count}=cell_voltage;
end
%%
V_sep1=volts_pulse300s_08soc_part(1:1600)'-voltage_pulse_sep{1};
V_sep2=volts_02soc_pulse300s_short_part(1:1600)'-voltage_pulse_sep{2};
V=V_sep1+V_sep2;
end