%% Do not* change anything in this file %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Time derivative by Backward Euler
% F(block1)=((dt)*A_cs-1)cs(t)+(dt)f_cs(cs(t))+cs(t-1)=0
% F(block2)=((dt)*A_ce-1)ce(t)+(dt)f_ce(cs(t))+ce(t-1)=0
% F(block3)=A_phie(ce)*[ce;phie]+f_phie
% F(block4)=A_phis*phis+f_phis+Biapp
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function F_phie=bat_F_phie(y_in)
global eta tem porosityNODE sv dx n_n n_s n_t n_p nr FARADAY RU ...
       tPlus alpha_a alpha_c concS_max_n...
       concS_max_p kcon_n kcon_p A_phie jli
phiE=y_in(1+n_n+n_p:n_n+n_p+n_t);
conc=y_in(n_n+n_p+n_t+1:n_n+n_p+n_t+n_t);
concS_surf=y_in((n_n+n_p)+n_t+n_t+nr*(n_n+n_p)+1:(n_n+n_p)+n_t+n_t+nr*(n_n+n_p)+n_t);
T=tem(1);
%% define BV equation
concS_max=zeros(1,n_t);concS_max(1:n_n)=concS_max_n;
concS_max(n_n+n_s+1:n_t)=concS_max_p;
kcon=zeros(1,n_t);kcon(1:n_n)=kcon_n;kcon(n_n+n_s+1:n_t)=kcon_p;
i0=kcon.*(conc.^alpha_a).*((concS_max-concS_surf).^alpha_a).*(concS_surf.^alpha_c);
exp1=exp((alpha_a * FARADAY/( RU * T ))* eta);
exp2= exp(-(alpha_c * FARADAY/( RU * T))* eta);
jli=sv.*i0.*(exp1-exp2);
%% define A_phie matrix
ce=conc.*1.0e-6;
m=exp(0.85 *(( ce.*1000).^1.4 ));
keff=100.0*15.8*(ce.*m).*(porosityNODE.^1.5); 
kd_eff=(keff.*(2*RU*T*(tPlus-1)/FARADAY));
keff_cell(1:n_n+n_s+n_p)=keff;
kd_eff_cell(1:n_n+n_s+n_p)=kd_eff;
% Left Boundary
keff_node(1) = keff_cell(1);
kd_eff_node(1)=kd_eff_cell(1);
for i=1:n_n+n_s+n_p-1
    keff_node(i+1)=(keff_cell(i)*dx(i)+keff_cell(i+1)*dx(i+1))/(dx(i)+dx(i+1));
    kd_eff_node(i+1)=(kd_eff_cell(i)*dx(i)+kd_eff_cell(i+1)*dx(i+1))/(dx(i)+dx(i+1));
end
% Right Boundary
keff_node(n_n+n_p+n_s+1) = keff_node(n_n+n_p+n_s);
kd_eff_node(n_n+n_p+n_s+1) = kd_eff_node(n_n+n_p+n_s);
%%%%%%%%%%%%%%% finite volume matrix %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i=1;
    A_phie(i,i)=-keff_node(i+1)*2/(dx(i)+dx(i+1));
    A_phie(i,i+1)=keff_node(i+1)*2/(dx(i)+dx(i+1));   
end
for i=2:n_n+n_s+n_p-1
    left=keff_node(i)*2/(dx(i)+dx(i-1));
    right=keff_node(i+1)*2/(dx(i)+dx(i+1));    
    A_phie(i,i-1)=left;
    A_phie(i,i)=-(left+right);
    A_phie(i,i+1)=right;
end

for i=n_n+n_s+n_p;   
    A_phie(i,i-1)=keff_node(i)*2/(dx(i)+dx(i-1));
    A_phie(i,i)=-keff_node(i)*2/(dx(i)+dx(i-1));
end
f_phie((n_n+n_s+n_p),1)=0;
for i=1
    f_phie(i)=jli(i)*dx(i)+(2*kd_eff_node(i+1)*(log(conc(i+1))-log(conc(i)))/(dx(i)+dx(i+1)));
end
for i=2:n_n+n_s+n_p-1
    f_phie(i)=jli(i)*dx(i)+(2*kd_eff_node(i+1)*(log(conc(i+1))-log(conc(i)))/(dx(i)+dx(i+1)))-(2*kd_eff_node(i)*(log(conc(i))-log(conc(i-1)))/(dx(i)+dx(i-1)));
end
for i=n_t
    f_phie(i)=jli(i)*dx(i)-(2*kd_eff_node(i)*(log(conc(i))-log(conc(i-1)))/(dx(i)+dx(i-1)));
end
F_phie=A_phie*(phiE')+f_phie;


