% post.m

% *************************************************************************

% Post Process

% Units are all International System of Units (SI)

% *************************************************************************

% Calculate battery voltage

v_left = phiS( 1 ) + i_app * dx( 1 ) * 0.5 / ( sigmaFACE( 1 ) );
v_right = phiS( end ) - i_app * dx( n_t ) * 0.5 / ( sigmaFACE( n_t + 1 ) );
cell_voltage(t) = v_right - v_left - resistance/A * i_app;

if( hybrid_cycle )
    display('hybrid cycle')
    dod(t)=i_app*dt/(capacity*3600);
%     fprintf( it * dt, app_curr(it), cell_voltage );
else
    if( charge == false )
        dod(t) = i_app * t * dt / ( capacity * 3600.0 );      % Normalized depth of discharge
%         fprintf( 'dod =%3.4f\t\tCell Voltage =%3.4f\n' ,  dod,  cell_voltage );
    else
        soc(t) = - i_app * t * dt / ( capacity * 3600.0);     % Normalized state of charge
%         fprintf( 'soc =%3.4f\t\tCell Voltage =%3.4f\n' ,  soc,  cell_voltage );
    end
end
      
% fprintf( '\t\t\t\tOpen Circuit Voltage =%3.4f\n\n' ,  eqpot( n_t ) - eqpot( 1 ) );

% subplot(2,1,1)
% if it > 1
%     plot([it-1,it],[cv_old,cell_voltage],'LineWidth',2)
%     drawnow
% end
% 
% subplot(2,1,2)
% if it > 1
%     plot([it-1,it],[app_curr(it-1)/6,app_curr(it)/6],'LineWidth',2)
%     drawnow
% end
% cv_old = cell_voltage;



% DONE***DONE***DONE***DONE***DONE***DONE***DONE***DONE***DONE***DONE***DONE